﻿namespace H2Guerilla.Controls
{
    using core.TagInterface;
    using H2Guerilla;
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;

    public class dataType : UserControl
    {
        private BaseObject baseobject;
        private IContainer components;
        private Label label1;
        private Label label2;
        public bool nulled;
        private TextBox textBox1;
        private bool waitForSave = true;

        public dataType(BaseObject BaseObject, bool Nulled)
        {
            this.baseobject = BaseObject;
            this.InitializeComponent();
            this.nulled = Nulled;
            this.label1.Text = this.baseobject.Name;
            this.label2.Text = "";
            Main.skin.skinChanged += new EventHandler(this.skin_skinChanged);
            this.BackColor = Main.skin.itemBackgroundColor;
            if (!Nulled)
            {
                this.LoadValue();
            }
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.textBox1 = new TextBox();
            this.label1 = new Label();
            this.label2 = new Label();
            base.SuspendLayout();
            this.textBox1.Location = new Point(0xb6, 3);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new Size(0x74, 20);
            this.textBox1.TabIndex = 0;
            this.textBox1.TextChanged += new EventHandler(this.textBox1_TextChanged);
            this.label1.AutoSize = true;
            this.label1.Location = new Point(12, 6);
            this.label1.Name = "label1";
            this.label1.Size = new Size(0x21, 13);
            this.label1.TabIndex = 1;
            this.label1.Text = "name";
            this.label2.AutoSize = true;
            this.label2.Location = new Point(0x130, 6);
            this.label2.Name = "label2";
            this.label2.Size = new Size(0x2f, 13);
            this.label2.TabIndex = 2;
            this.label2.Text = "extrainfo";
            base.AutoScaleDimensions = new SizeF(6f, 13f);
            base.AutoScaleMode = AutoScaleMode.Font;
            this.AutoSize = true;
            base.AutoSizeMode = AutoSizeMode.GrowAndShrink;
            base.Controls.Add(this.label2);
            base.Controls.Add(this.label1);
            base.Controls.Add(this.textBox1);
            base.Name = "dataType";
            base.Size = new Size(0x162, 0x1a);
            base.ResumeLayout(false);
            base.PerformLayout();
        }

        private void LoadValue()
        {
            this.label1.Text = this.baseobject.Name;
            this.label2.Text = "";
            if (this.baseobject is Angle)
            {
                this.label2.Text = "degrees";
                Angle baseobject = (Angle) this.baseobject;
                this.textBox1.Text = baseobject.AngleInDegrees.ToString();
            }
            else if (this.baseobject is ByteInteger)
            {
                ByteInteger integer = (ByteInteger) this.baseobject;
                this.textBox1.Text = integer.Byte.ToString();
            }
            else if (this.baseobject is LongInteger)
            {
                LongInteger integer2 = (LongInteger) this.baseobject;
                this.textBox1.Text = integer2.Long.ToString();
            }
            else if (this.baseobject is RawDataOffset)
            {
                RawDataOffset offset = (RawDataOffset) this.baseobject;
                this.textBox1.Text = offset.Data_Offset.ToString();
            }
            else if (this.baseobject is RealFloat)
            {
                RealFloat num = (RealFloat) this.baseobject;
                this.textBox1.Text = num.Float.ToString();
            }
            else if (this.baseobject is RealFraction)
            {
                RealFraction fraction = (RealFraction) this.baseobject;
                this.textBox1.Text = fraction.Fraction.ToString();
            }
            else if (this.baseobject is ShortInteger)
            {
                ShortInteger integer3 = (ShortInteger) this.baseobject;
                this.textBox1.Text = integer3.Short.ToString();
            }
            else if (this.baseobject is core.TagInterface.String)
            {
                core.TagInterface.String str = (core.TagInterface.String) this.baseobject;
                this.textBox1.Text = str.Text;
            }
            else if (this.baseobject is StringID)
            {
                StringID gid = (StringID) this.baseobject;
                this.textBox1.Text = gid.Text;
            }
            else if (this.baseobject is HaloTagType)
            {
                HaloTagType type = (HaloTagType) this.baseobject;
                this.textBox1.Text = type.TagType;
            }
            this.waitForSave = false;
        }

        public void ReloadWithNewBaseObject(BaseObject BaseObject)
        {
            this.baseobject = BaseObject;
            this.LoadValue();
        }

        private void SaveValue()
        {
            if (!this.nulled && !this.waitForSave)
            {
                if (this.baseobject is Angle)
                {
                    Angle baseobject = (Angle) this.baseobject;
                    baseobject.AngleInDegrees = float.Parse(this.textBox1.Text);
                }
                else if (this.baseobject is ByteInteger)
                {
                    ByteInteger integer = (ByteInteger) this.baseobject;
                    integer.Byte = byte.Parse(this.textBox1.Text);
                }
                else if (this.baseobject is LongInteger)
                {
                    LongInteger integer2 = (LongInteger) this.baseobject;
                    integer2.Long = int.Parse(this.textBox1.Text);
                }
                else if (this.baseobject is RawDataOffset)
                {
                    RawDataOffset offset = (RawDataOffset) this.baseobject;
                    offset.Data_Offset = int.Parse(this.textBox1.Text);
                }
                else if (this.baseobject is RealFloat)
                {
                    RealFloat num = (RealFloat) this.baseobject;
                    num.Float = float.Parse(this.textBox1.Text);
                }
                else if (this.baseobject is RealFraction)
                {
                    RealFraction fraction = (RealFraction) this.baseobject;
                    fraction.Fraction = float.Parse(this.textBox1.Text);
                }
                else if (this.baseobject is ShortInteger)
                {
                    ShortInteger integer3 = (ShortInteger) this.baseobject;
                    integer3.Short = short.Parse(this.textBox1.Text);
                }
                else if (this.baseobject is core.TagInterface.String)
                {
                    core.TagInterface.String str = (core.TagInterface.String) this.baseobject;
                    str.Text = this.textBox1.Text;
                }
                else if (this.baseobject is StringID)
                {
                    StringID gid = (StringID) this.baseobject;
                    gid.Text = this.textBox1.Text;
                }
                else if (this.baseobject is HaloTagType)
                {
                    HaloTagType type = (HaloTagType) this.baseobject;
                    type.TagType = this.textBox1.Text;
                }
            }
        }

        public void SetNull()
        {
            this.nulled = true;
            this.textBox1.Clear();
        }

        private void skin_skinChanged(object sender, EventArgs e)
        {
            this.BackColor = Main.skin.itemBackgroundColor;
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            this.SaveValue();
        }
    }
}

