﻿namespace H2Guerilla.Forms
{
    using H2Guerilla.Classes;
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;

    public class DatabaseExtract : Form
    {
        private Button button1;
        private Button button2;
        private IContainer components;
        private Label label1;
        private Label label2;
        private Label label3;
        private Label label4;
        private Label label5;
        private Label label6;
        private Label label7;
        private Label label8;
        private PictureBox pictureBox1;
        private TextBox textBox1;

        public DatabaseExtract()
        {
            this.InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.Filter = "H2G Database File|*.h2gdf";
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                this.textBox1.Text = dialog.FileName;
                H2DatabaseHandler.DatabaseHeader header = H2DatabaseHandler.ReadDatabaseHeader(dialog.FileName);
                this.label3.Text = header.Version;
                this.label5.Text = header.Author;
                this.label7.Text = header.Description;
                this.pictureBox1.Image = header.Image;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            base.Enabled = false;
            H2DatabaseHandler.ExtractDatabaseStart(this.textBox1.Text);
            base.Enabled = true;
            base.Close();
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.label1 = new Label();
            this.textBox1 = new TextBox();
            this.button1 = new Button();
            this.label2 = new Label();
            this.label3 = new Label();
            this.label4 = new Label();
            this.label5 = new Label();
            this.label6 = new Label();
            this.label7 = new Label();
            this.label8 = new Label();
            this.pictureBox1 = new PictureBox();
            this.button2 = new Button();
            ((ISupportInitialize) this.pictureBox1).BeginInit();
            base.SuspendLayout();
            this.label1.AutoSize = true;
            this.label1.Location = new Point(0x16, 9);
            this.label1.Name = "label1";
            this.label1.Size = new Size(0x33, 13);
            this.label1.TabIndex = 0;
            this.label1.Text = "File Path:";
            this.textBox1.Location = new Point(0x65, 6);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new Size(0x112, 20);
            this.textBox1.TabIndex = 1;
            this.button1.Location = new Point(0x17d, 3);
            this.button1.Name = "button1";
            this.button1.Size = new Size(0x1a, 0x17);
            this.button1.TabIndex = 2;
            this.button1.Text = "...";
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Click += new EventHandler(this.button1_Click);
            this.label2.AutoSize = true;
            this.label2.Location = new Point(0x16, 0x27);
            this.label2.Name = "label2";
            this.label2.Size = new Size(0x2d, 13);
            this.label2.TabIndex = 3;
            this.label2.Text = "Version:";
            this.label3.Location = new Point(0x62, 0x27);
            this.label3.Name = "label3";
            this.label3.Size = new Size(0x115, 0x17);
            this.label3.TabIndex = 4;
            this.label3.Text = "N/A";
            this.label4.AutoSize = true;
            this.label4.Location = new Point(0x16, 0x3e);
            this.label4.Name = "label4";
            this.label4.Size = new Size(0x29, 13);
            this.label4.TabIndex = 5;
            this.label4.Text = "Author:";
            this.label5.Location = new Point(0x62, 0x3e);
            this.label5.Name = "label5";
            this.label5.Size = new Size(0x115, 0x17);
            this.label5.TabIndex = 6;
            this.label5.Text = "N/A";
            this.label6.AutoSize = true;
            this.label6.Location = new Point(0x16, 0x58);
            this.label6.Name = "label6";
            this.label6.Size = new Size(0x3f, 13);
            this.label6.TabIndex = 7;
            this.label6.Text = "Description:";
            this.label7.Location = new Point(0x62, 0x58);
            this.label7.Name = "label7";
            this.label7.Size = new Size(270, 0x39);
            this.label7.TabIndex = 8;
            this.label7.Text = "N/A";
            this.label8.AutoSize = true;
            this.label8.Location = new Point(0x16, 0x94);
            this.label8.Name = "label8";
            this.label8.Size = new Size(80, 13);
            this.label8.TabIndex = 9;
            this.label8.Text = "Preivew Image:";
            this.pictureBox1.BorderStyle = BorderStyle.FixedSingle;
            this.pictureBox1.Location = new Point(0x65, 0x94);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new Size(0x10b, 0xb2);
            this.pictureBox1.SizeMode = PictureBoxSizeMode.Zoom;
            this.pictureBox1.TabIndex = 10;
            this.pictureBox1.TabStop = false;
            this.button2.Location = new Point(0x9e, 0x153);
            this.button2.Name = "button2";
            this.button2.Size = new Size(0x71, 0x17);
            this.button2.TabIndex = 11;
            this.button2.Text = "Extract Database";
            this.button2.UseVisualStyleBackColor = true;
            this.button2.Click += new EventHandler(this.button2_Click);
            base.AutoScaleDimensions = new SizeF(6f, 13f);
            base.AutoScaleMode = AutoScaleMode.Font;
            base.ClientSize = new Size(0x1ac, 0x173);
            base.Controls.Add(this.button2);
            base.Controls.Add(this.pictureBox1);
            base.Controls.Add(this.label8);
            base.Controls.Add(this.label7);
            base.Controls.Add(this.label6);
            base.Controls.Add(this.label5);
            base.Controls.Add(this.label4);
            base.Controls.Add(this.label3);
            base.Controls.Add(this.label2);
            base.Controls.Add(this.button1);
            base.Controls.Add(this.textBox1);
            base.Controls.Add(this.label1);
            base.Name = "DatabaseExtract";
            this.Text = "Database Extractor";
            ((ISupportInitialize) this.pictureBox1).EndInit();
            base.ResumeLayout(false);
            base.PerformLayout();
        }
    }
}

