﻿namespace H2Guerilla.Controls
{
    using core.TagInterface;
    using H2Guerilla;
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;

    public class flags : UserControl
    {
        private BaseObject baseobject;
        private CheckedListBox checkedListBox1;
        private IContainer components;
        private Label label1;
        public bool nulled;
        private bool waitTillLoad = true;

        public flags(BaseObject BaseObject, bool Nulled)
        {
            this.baseobject = BaseObject;
            this.InitializeComponent();
            this.nulled = Nulled;
            Main.skin.skinChanged += new EventHandler(this.skin_skinChanged);
            this.BackColor = Main.skin.itemBackgroundColor;
            if (!Nulled)
            {
                this.LoadValue();
            }
        }

        private void checkedListBox1_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            this.SaveValue();
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.label1 = new Label();
            this.checkedListBox1 = new CheckedListBox();
            base.SuspendLayout();
            this.label1.AutoSize = true;
            this.label1.Location = new Point(12, 3);
            this.label1.Name = "label1";
            this.label1.Size = new Size(0x23, 13);
            this.label1.TabIndex = 0;
            this.label1.Text = "label1";
            this.checkedListBox1.FormattingEnabled = true;
            this.checkedListBox1.Location = new Point(0xb6, 3);
            this.checkedListBox1.Name = "checkedListBox1";
            this.checkedListBox1.Size = new Size(0xa7, 0xa9);
            this.checkedListBox1.TabIndex = 1;
            this.checkedListBox1.ItemCheck += new ItemCheckEventHandler(this.checkedListBox1_ItemCheck);
            base.AutoScaleDimensions = new SizeF(6f, 13f);
            base.AutoScaleMode = AutoScaleMode.Font;
            this.AutoSize = true;
            base.AutoSizeMode = AutoSizeMode.GrowAndShrink;
            base.Controls.Add(this.checkedListBox1);
            base.Controls.Add(this.label1);
            base.Name = "flags";
            base.Size = new Size(0x160, 0xaf);
            base.ResumeLayout(false);
            base.PerformLayout();
        }

        private void LoadValue()
        {
            core.TagInterface.Flags baseobject = (core.TagInterface.Flags) this.baseobject;
            this.label1.Text = baseobject.Name;
            this.checkedListBox1.Items.Clear();
            for (int i = 0; i < baseobject.Bits.Count; i++)
            {
                CheckListBoxItem item = new CheckListBoxItem(baseobject.Bits[i].BitName);
                item.Tag = i;
                this.checkedListBox1.Items.Add(item, baseobject.Bits[i].BitEnabled);
            }
            this.waitTillLoad = false;
        }

        public void ReloadWithNewBaseObject(BaseObject BaseObject)
        {
            this.baseobject = BaseObject;
            this.waitTillLoad = true;
            this.LoadValue();
        }

        private void SaveValue()
        {
            if (!this.waitTillLoad && !this.nulled)
            {
                core.TagInterface.Flags baseobject = (core.TagInterface.Flags) this.baseobject;
                for (int i = 0; i < baseobject.Bits.Count; i++)
                {
                    core.TagInterface.Flags.Bit bit = baseobject.Bits[i];
                    bit.BitEnabled = this.checkedListBox1.GetItemChecked(i);
                    baseobject.Bits[i] = bit;
                }
            }
        }

        public void SetNull()
        {
            this.nulled = true;
            this.checkedListBox1.Items.Clear();
        }

        private void skin_skinChanged(object sender, EventArgs e)
        {
            this.BackColor = Main.skin.itemBackgroundColor;
        }

        public class CheckListBoxItem
        {
            private object tag;
            private string text;

            public CheckListBoxItem(string Text)
            {
                this.text = Text;
            }

            public override string ToString()
            {
                return this.text;
            }

            public object Tag
            {
                get
                {
                    return this.tag;
                }
                set
                {
                    this.tag = value;
                }
            }

            public string Text
            {
                get
                {
                    return this.text;
                }
                set
                {
                    this.text = value;
                }
            }
        }
    }
}

