﻿namespace H2Guerilla.Controls
{
    using core.TagInterface;
    using H2Guerilla;
    using H2Guerilla.Classes;
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;

    public class reflexives : UserControl
    {
        private BaseObject baseobject;
        private Button button1;
        private Button button2;
        private Button button3;
        private Button button4;
        private Button button5;
        private Button button6;
        private Button button7;
        private Button button8;
        private ComboBox comboBox1;
        private IContainer components;
        private Label label1;
        private Panel panel1;
        private Panel panel2;
        private bool waitforLoad = true;

        public reflexives(BaseObject BaseObject)
        {
            this.baseobject = BaseObject;
            Main.skin.skinChanged += new EventHandler(this.skin_skinChanged);
            this.InitializeComponent();
            this.BackColor = Main.skin.formBackgroundColor;
            this.panel2.BackColor = Main.skin.reflexiveColor;
            this.panel1.BackColor = Main.skin.reflexiveColor2;
            this.LoadValue();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.waitforLoad = true;
            TagBlock baseobject = (TagBlock) this.baseobject;
            baseobject.AddNewChunk();
            int num = baseobject.Chunks.Count - 1;
            this.comboBox1.Items.Add(num.ToString());
            this.waitforLoad = false;
            this.comboBox1.SelectedIndex = this.comboBox1.Items.Count - 1;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.waitforLoad = true;
            TagBlock baseobject = (TagBlock) this.baseobject;
            int num = 0;
            int selectedIndex = this.comboBox1.SelectedIndex;
            if (selectedIndex == -1)
            {
                selectedIndex = 0;
            }
            using (List<TagBlockLayout>.Enumerator enumerator = Main.copyForReflexive.GetEnumerator())
            {
                while (enumerator.MoveNext())
                {
                    TagBlockLayout current = enumerator.Current;
                    baseobject.InsertChunk(Main.copyForReflexive[num], selectedIndex + num);
                    int num3 = baseobject.Chunks.Count - 1;
                    this.comboBox1.Items.Add(num3.ToString());
                    num++;
                }
            }
            this.waitforLoad = false;
            this.comboBox1.SelectedIndex = baseobject.ChunkCount - 1;
            if (this.comboBox1.SelectedIndex != -1)
            {
                this.comboBox1_SelectedIndexChanged(null, null);
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            this.waitforLoad = true;
            TagBlock baseobject = (TagBlock) this.baseobject;
            baseobject.CloneChunk(this.comboBox1.SelectedIndex);
            int num = baseobject.Chunks.Count - 1;
            this.comboBox1.Items.Add(num.ToString());
            this.waitforLoad = false;
            this.comboBox1.SelectedIndex = this.comboBox1.Items.Count - 1;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            this.waitforLoad = true;
            TagBlock baseobject = (TagBlock) this.baseobject;
            baseobject.RemoveChunk(this.comboBox1.SelectedIndex);
            if (this.comboBox1.SelectedIndex == (this.comboBox1.Items.Count - 1))
            {
                this.comboBox1.SelectedIndex--;
            }
            this.comboBox1.Items.RemoveAt(this.comboBox1.Items.Count - 1);
            if (this.comboBox1.Items.Count == 0)
            {
                this.button8.Enabled = false;
                this.button3.Enabled = false;
                this.button4.Enabled = false;
                this.button5.Enabled = false;
                this.button6.Enabled = false;
                this.panel1.Enabled = false;
                this.comboBox1.Text = "";
                this.waitforLoad = false;
                this.ReloadNulled(baseobject);
            }
            this.waitforLoad = false;
            this.comboBox1_SelectedIndexChanged(null, null);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            this.waitforLoad = true;
            TagBlock baseobject = (TagBlock) this.baseobject;
            baseobject.RemoveAllChunks();
            this.comboBox1.Items.Clear();
            this.button8.Enabled = false;
            this.button3.Enabled = false;
            this.button4.Enabled = false;
            this.button5.Enabled = false;
            this.button6.Enabled = false;
            this.panel1.Enabled = false;
            this.comboBox1.Text = "";
            this.waitforLoad = false;
            this.ReloadNulled(baseobject);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            Main.copyForReflexive.Clear();
            TagBlock baseobject = (TagBlock) this.baseobject;
            Main.copyForReflexive.Add(baseobject.GetChunk(this.comboBox1.SelectedIndex).Clone());
            MessageBox.Show("Chunk Copied");
        }

        private void button7_Click(object sender, EventArgs e)
        {
            if (this.button7.Text == "-")
            {
                this.button7.Text = "+";
                this.AutoSize = false;
                base.Height = 40;
            }
            else
            {
                this.button7.Text = "-";
                this.AutoSize = true;
            }
        }

        private void button8_Click(object sender, EventArgs e)
        {
            Main.copyForReflexive.Clear();
            TagBlock baseobject = (TagBlock) this.baseobject;
            for (int i = 0; i < baseobject.ChunkCount; i++)
            {
                Main.copyForReflexive.Add(baseobject.GetChunk(i).Clone());
            }
            MessageBox.Show("Chunks Copied");
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            TagBlock baseobject = (TagBlock) this.baseobject;
            this.Reload(baseobject, this.comboBox1.SelectedIndex);
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.button1 = new Button();
            this.button2 = new Button();
            this.button3 = new Button();
            this.button4 = new Button();
            this.button5 = new Button();
            this.comboBox1 = new ComboBox();
            this.label1 = new Label();
            this.panel1 = new Panel();
            this.button6 = new Button();
            this.button7 = new Button();
            this.panel2 = new Panel();
            this.button8 = new Button();
            this.panel2.SuspendLayout();
            base.SuspendLayout();
            this.button1.BackColor = SystemColors.Control;
            this.button1.Location = new Point(0x12e, 3);
            this.button1.Name = "button1";
            this.button1.Size = new Size(0x27, 0x17);
            this.button1.TabIndex = 0;
            this.button1.Text = "Add";
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Click += new EventHandler(this.button1_Click);
            this.button2.BackColor = SystemColors.Control;
            this.button2.Location = new Point(0x15b, 3);
            this.button2.Name = "button2";
            this.button2.Size = new Size(0x2d, 0x17);
            this.button2.TabIndex = 1;
            this.button2.Text = "Insert";
            this.button2.UseVisualStyleBackColor = true;
            this.button2.Click += new EventHandler(this.button2_Click);
            this.button3.BackColor = SystemColors.Control;
            this.button3.Enabled = false;
            this.button3.Location = new Point(0x1f9, 3);
            this.button3.Name = "button3";
            this.button3.Size = new Size(0x40, 0x17);
            this.button3.TabIndex = 2;
            this.button3.Text = "Duplicate";
            this.button3.UseVisualStyleBackColor = true;
            this.button3.Click += new EventHandler(this.button3_Click);
            this.button4.BackColor = SystemColors.Control;
            this.button4.Enabled = false;
            this.button4.Location = new Point(0x23f, 3);
            this.button4.Name = "button4";
            this.button4.Size = new Size(0x36, 0x17);
            this.button4.TabIndex = 3;
            this.button4.Text = "Delete";
            this.button4.UseVisualStyleBackColor = true;
            this.button4.Click += new EventHandler(this.button4_Click);
            this.button5.BackColor = SystemColors.Control;
            this.button5.Enabled = false;
            this.button5.Location = new Point(0x27b, 3);
            this.button5.Name = "button5";
            this.button5.Size = new Size(70, 0x17);
            this.button5.TabIndex = 4;
            this.button5.Text = "Delete All";
            this.button5.UseVisualStyleBackColor = true;
            this.button5.Click += new EventHandler(this.button5_Click);
            this.comboBox1.FormattingEnabled = true;
            this.comboBox1.Location = new Point(0xaf, 5);
            this.comboBox1.Name = "comboBox1";
            this.comboBox1.Size = new Size(0x79, 0x15);
            this.comboBox1.TabIndex = 5;
            this.comboBox1.SelectedIndexChanged += new EventHandler(this.comboBox1_SelectedIndexChanged);
            this.label1.AutoSize = true;
            this.label1.ForeColor = Color.White;
            this.label1.Location = new Point(40, 8);
            this.label1.Name = "label1";
            this.label1.Size = new Size(0x23, 13);
            this.label1.TabIndex = 6;
            this.label1.Text = "label1";
            this.panel1.AutoSize = true;
            this.panel1.BackColor = SystemColors.Control;
            this.panel1.Location = new Point(4, 0x20);
            this.panel1.Margin = new System.Windows.Forms.Padding(20, 3, 0, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new Size(0x2c2, 0x1a);
            this.panel1.TabIndex = 7;
            this.button6.BackColor = SystemColors.Control;
            this.button6.Enabled = false;
            this.button6.Location = new Point(0x18e, 3);
            this.button6.Name = "button6";
            this.button6.Size = new Size(0x27, 0x17);
            this.button6.TabIndex = 8;
            this.button6.Text = "Copy";
            this.button6.UseVisualStyleBackColor = true;
            this.button6.Click += new EventHandler(this.button6_Click);
            this.button7.BackColor = SystemColors.Control;
            this.button7.FlatStyle = FlatStyle.Flat;
            this.button7.Location = new Point(4, 3);
            this.button7.Name = "button7";
            this.button7.Size = new Size(30, 0x17);
            this.button7.TabIndex = 0;
            this.button7.Text = "+";
            this.button7.UseVisualStyleBackColor = false;
            this.button7.Click += new EventHandler(this.button7_Click);
            this.panel2.AutoSize = true;
            this.panel2.AutoSizeMode = AutoSizeMode.GrowAndShrink;
            this.panel2.BackColor = SystemColors.ControlDark;
            this.panel2.Controls.Add(this.button8);
            this.panel2.Controls.Add(this.button7);
            this.panel2.Controls.Add(this.button1);
            this.panel2.Controls.Add(this.button6);
            this.panel2.Controls.Add(this.button2);
            this.panel2.Controls.Add(this.panel1);
            this.panel2.Controls.Add(this.button3);
            this.panel2.Controls.Add(this.label1);
            this.panel2.Controls.Add(this.button4);
            this.panel2.Controls.Add(this.comboBox1);
            this.panel2.Controls.Add(this.button5);
            this.panel2.Location = new Point(8, 8);
            this.panel2.Margin = new System.Windows.Forms.Padding(0);
            this.panel2.Name = "panel2";
            this.panel2.Size = new Size(710, 0x3a);
            this.panel2.TabIndex = 9;
            this.button8.BackColor = SystemColors.Control;
            this.button8.Enabled = false;
            this.button8.Location = new Point(0x1bb, 3);
            this.button8.Name = "button8";
            this.button8.Size = new Size(0x38, 0x17);
            this.button8.TabIndex = 9;
            this.button8.Text = "Copy All";
            this.button8.UseVisualStyleBackColor = true;
            this.button8.Click += new EventHandler(this.button8_Click);
            base.AutoScaleDimensions = new SizeF(6f, 13f);
            base.AutoScaleMode = AutoScaleMode.Font;
            this.AutoSize = true;
            base.AutoSizeMode = AutoSizeMode.GrowAndShrink;
            this.BackColor = SystemColors.Control;
            base.Controls.Add(this.panel2);
            base.Name = "reflexives";
            base.Size = new Size(0x2ce, 0x42);
            this.panel2.ResumeLayout(false);
            this.panel2.PerformLayout();
            base.ResumeLayout(false);
            base.PerformLayout();
        }

        private void LoadControls(Control container, TagBlock tagblock)
        {
            this.label1.Text = tagblock.Name;
            if (tagblock.Chunks.Count == 0)
            {
                container.Enabled = false;
                this.LoadFromLayout(container, tagblock, true);
            }
            else
            {
                this.button8.Enabled = true;
                this.button3.Enabled = true;
                this.button4.Enabled = true;
                this.button5.Enabled = true;
                this.button6.Enabled = true;
                for (int i = 0; i < tagblock.ChunkCount; i++)
                {
                    this.comboBox1.Items.Add(i.ToString());
                }
                this.comboBox1.SelectedIndex = 0;
                TagBlockLayout tagBlock = tagblock.Chunks[0];
                foreach (Control control in TagBlockHelper.getControlsFromLayout(tagBlock, false))
                {
                    container.Controls.Add(control);
                    control.Dock = DockStyle.Top;
                    control.BringToFront();
                }
            }
        }

        private void LoadFromLayout(Control container, TagBlock tagblock, bool Nulled)
        {
            foreach (Control control in TagBlockHelper.getControlsFromLayout(tagblock.Layout, Nulled))
            {
                container.Controls.Add(control);
                control.Dock = DockStyle.Top;
                control.BringToFront();
            }
        }

        public void LoadValue()
        {
            this.AutoSize = false;
            this.button7.Text = "+";
            base.Height = 40;
            TagBlock baseobject = (TagBlock) this.baseobject;
            this.LoadControls(this.panel1, baseobject);
            this.waitforLoad = false;
        }

        public void Reload(TagBlock tagblock, int ChunkIndex)
        {
            if (!this.waitforLoad && (tagblock.Chunks.Count != 0))
            {
                this.panel1.Enabled = true;
                this.button8.Enabled = true;
                this.button3.Enabled = true;
                this.button4.Enabled = true;
                this.button5.Enabled = true;
                this.button6.Enabled = true;
                TagBlockLayout tagBlock = tagblock.Chunks[ChunkIndex];
                TagBlockHelper.reloadControlsWithNewBaseObject(this.panel1, tagBlock, false);
            }
        }

        public void ReloadNulled(TagBlock tagbloack)
        {
            TagBlockLayout tagBlock = tagbloack.Layout;
            TagBlockHelper.reloadControlsWithNewBaseObject(this.panel1, tagBlock, true);
        }

        public void ReloadWithNewBaseObject(BaseObject BaseObject, bool Nulled)
        {
            this.baseobject = BaseObject;
            if (Nulled)
            {
                this.SetNull();
            }
            else if (((TagBlock) this.baseobject).ChunkCount != 0)
            {
                this.comboBox1.Items.Clear();
                for (int i = 0; i < ((TagBlock) this.baseobject).ChunkCount; i++)
                {
                    this.comboBox1.Items.Add(i.ToString());
                }
                TagBlock baseobject = (TagBlock) this.baseobject;
                this.comboBox1.SelectedIndex = 0;
                this.Reload(baseobject, 0);
            }
        }

        public void SetNull()
        {
            this.ReloadNulled((TagBlock) this.baseobject);
        }

        private void skin_skinChanged(object sender, EventArgs e)
        {
            this.BackColor = Main.skin.formBackgroundColor;
            this.panel2.BackColor = Main.skin.reflexiveColor;
            this.panel1.BackColor = Main.skin.reflexiveColor2;
        }
    }
}

