﻿namespace H2Guerilla.Forms
{
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.IO;
    using System.Runtime.CompilerServices;
    using System.Runtime.InteropServices;
    using System.Windows.Forms;

    public class Skin : Form
    {
        private Button button1;
        private Button button2;
        private IContainer components;
        public Color formBackgroundColor = Color.FromName("Control");
        public Color itemBackgroundColor = Color.FromName("Control");
        private Label label1;
        private Label label2;
        private Label label3;
        private Label label4;
        private PictureBox pictureBox1;
        private PictureBox pictureBox2;
        private PictureBox pictureBox3;
        private PictureBox pictureBox4;
        public Color reflexiveColor = Color.FromName("ControlDark");
        public Color reflexiveColor2 = Color.FromName("Control");

        public event EventHandler skinChanged;

        public Skin()
        {
            this.InitializeComponent();
            this.LoadSkin();
            this.pictureBox1.BackColor = this.reflexiveColor;
            this.pictureBox2.BackColor = this.reflexiveColor2;
            this.pictureBox3.BackColor = this.formBackgroundColor;
            this.pictureBox4.BackColor = this.itemBackgroundColor;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.saveSkin();
            this.ChangeSkin();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            base.Close();
        }

        public void ChangeSkin()
        {
            if (this.skinChanged != null)
            {
                this.skinChanged(null, null);
            }
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.pictureBox1 = new PictureBox();
            this.pictureBox2 = new PictureBox();
            this.pictureBox3 = new PictureBox();
            this.pictureBox4 = new PictureBox();
            this.label1 = new Label();
            this.label2 = new Label();
            this.label3 = new Label();
            this.label4 = new Label();
            this.button1 = new Button();
            this.button2 = new Button();
            ((ISupportInitialize) this.pictureBox1).BeginInit();
            ((ISupportInitialize) this.pictureBox2).BeginInit();
            ((ISupportInitialize) this.pictureBox3).BeginInit();
            ((ISupportInitialize) this.pictureBox4).BeginInit();
            base.SuspendLayout();
            this.pictureBox1.BorderStyle = BorderStyle.FixedSingle;
            this.pictureBox1.Location = new Point(0x92, 12);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new Size(0x43, 50);
            this.pictureBox1.TabIndex = 0;
            this.pictureBox1.TabStop = false;
            this.pictureBox1.Click += new EventHandler(this.pictureBox1_Click);
            this.pictureBox2.BorderStyle = BorderStyle.FixedSingle;
            this.pictureBox2.Location = new Point(0x92, 0x44);
            this.pictureBox2.Name = "pictureBox2";
            this.pictureBox2.Size = new Size(0x43, 50);
            this.pictureBox2.TabIndex = 1;
            this.pictureBox2.TabStop = false;
            this.pictureBox2.Click += new EventHandler(this.pictureBox2_Click);
            this.pictureBox3.BorderStyle = BorderStyle.FixedSingle;
            this.pictureBox3.Location = new Point(0x92, 0x7c);
            this.pictureBox3.Name = "pictureBox3";
            this.pictureBox3.Size = new Size(0x43, 50);
            this.pictureBox3.TabIndex = 2;
            this.pictureBox3.TabStop = false;
            this.pictureBox3.Click += new EventHandler(this.pictureBox3_Click);
            this.pictureBox4.BorderStyle = BorderStyle.FixedSingle;
            this.pictureBox4.Location = new Point(0x92, 180);
            this.pictureBox4.Name = "pictureBox4";
            this.pictureBox4.Size = new Size(0x43, 50);
            this.pictureBox4.TabIndex = 3;
            this.pictureBox4.TabStop = false;
            this.pictureBox4.Click += new EventHandler(this.pictureBox4_Click);
            this.label1.AutoSize = true;
            this.label1.Location = new Point(0x1a, 0x21);
            this.label1.Name = "label1";
            this.label1.Size = new Size(0x57, 13);
            this.label1.TabIndex = 4;
            this.label1.Text = "Reflexive Color 1";
            this.label2.AutoSize = true;
            this.label2.Location = new Point(0x1a, 0x58);
            this.label2.Name = "label2";
            this.label2.Size = new Size(0x57, 13);
            this.label2.TabIndex = 5;
            this.label2.Text = "Reflexive Color 2";
            this.label3.AutoSize = true;
            this.label3.Location = new Point(0x1a, 0x90);
            this.label3.Name = "label3";
            this.label3.Size = new Size(0x76, 13);
            this.label3.TabIndex = 6;
            this.label3.Text = "Form Background Color";
            this.label4.AutoSize = true;
            this.label4.Location = new Point(0x1a, 0xc9);
            this.label4.Name = "label4";
            this.label4.Size = new Size(0x73, 13);
            this.label4.TabIndex = 7;
            this.label4.Text = "Item Background Color";
            this.button1.Location = new Point(0x1d, 0xf9);
            this.button1.Name = "button1";
            this.button1.Size = new Size(0x4b, 0x17);
            this.button1.TabIndex = 8;
            this.button1.Text = "Save";
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Click += new EventHandler(this.button1_Click);
            this.button2.Location = new Point(110, 0xf9);
            this.button2.Name = "button2";
            this.button2.Size = new Size(0x4b, 0x17);
            this.button2.TabIndex = 9;
            this.button2.Text = "Close";
            this.button2.UseVisualStyleBackColor = true;
            this.button2.Click += new EventHandler(this.button2_Click);
            base.AutoScaleDimensions = new SizeF(6f, 13f);
            base.AutoScaleMode = AutoScaleMode.Font;
            base.ClientSize = new Size(0xef, 0x125);
            base.Controls.Add(this.button2);
            base.Controls.Add(this.button1);
            base.Controls.Add(this.label4);
            base.Controls.Add(this.label3);
            base.Controls.Add(this.label2);
            base.Controls.Add(this.label1);
            base.Controls.Add(this.pictureBox4);
            base.Controls.Add(this.pictureBox3);
            base.Controls.Add(this.pictureBox2);
            base.Controls.Add(this.pictureBox1);
            base.Name = "Skin";
            this.Text = "Skin Options";
            ((ISupportInitialize) this.pictureBox1).EndInit();
            ((ISupportInitialize) this.pictureBox2).EndInit();
            ((ISupportInitialize) this.pictureBox3).EndInit();
            ((ISupportInitialize) this.pictureBox4).EndInit();
            base.ResumeLayout(false);
            base.PerformLayout();
        }

        public void LoadSkin()
        {
            string path = Application.StartupPath + @"\skininfo.skin";
            if (File.Exists(path))
            {
                try
                {
                    FileStream stream = new FileStream(path, FileMode.Open, FileAccess.Read);
                    StreamReader reader = new StreamReader(stream);
                    string[] strArray = reader.ReadLine().Split(new char[] { ',' });
                    this.reflexiveColor = Color.FromArgb(int.Parse(strArray[0]), int.Parse(strArray[1]), int.Parse(strArray[2]));
                    strArray = reader.ReadLine().Split(new char[] { ',' });
                    this.reflexiveColor2 = Color.FromArgb(int.Parse(strArray[0]), int.Parse(strArray[1]), int.Parse(strArray[2]));
                    strArray = reader.ReadLine().Split(new char[] { ',' });
                    this.formBackgroundColor = Color.FromArgb(int.Parse(strArray[0]), int.Parse(strArray[1]), int.Parse(strArray[2]));
                    strArray = reader.ReadLine().Split(new char[] { ',' });
                    this.itemBackgroundColor = Color.FromArgb(int.Parse(strArray[0]), int.Parse(strArray[1]), int.Parse(strArray[2]));
                    reader.Close();
                    stream.Close();
                }
                catch
                {
                    this.saveSkin();
                    this.LoadSkin();
                }
            }
            else
            {
                this.saveSkin();
            }
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
            ColorDialog dialog = new ColorDialog();
            dialog.FullOpen = true;
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                this.pictureBox1.BackColor = dialog.Color;
                this.reflexiveColor = dialog.Color;
            }
        }

        private void pictureBox2_Click(object sender, EventArgs e)
        {
            ColorDialog dialog = new ColorDialog();
            dialog.FullOpen = true;
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                this.pictureBox2.BackColor = dialog.Color;
                this.reflexiveColor2 = dialog.Color;
            }
        }

        private void pictureBox3_Click(object sender, EventArgs e)
        {
            ColorDialog dialog = new ColorDialog();
            dialog.FullOpen = true;
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                this.pictureBox3.BackColor = dialog.Color;
                this.formBackgroundColor = dialog.Color;
            }
        }

        private void pictureBox4_Click(object sender, EventArgs e)
        {
            ColorDialog dialog = new ColorDialog();
            dialog.FullOpen = true;
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                this.pictureBox4.BackColor = dialog.Color;
                this.itemBackgroundColor = dialog.Color;
            }
        }

        public void saveSkin()
        {
            FileStream stream = new FileStream(Application.StartupPath + @"\skininfo.skin", FileMode.Create, FileAccess.Write);
            StreamWriter writer = new StreamWriter(stream);
            writer.WriteLine(this.reflexiveColor.R.ToString() + "," + this.reflexiveColor.G.ToString() + "," + this.reflexiveColor.B.ToString());
            writer.WriteLine(this.reflexiveColor2.R.ToString() + "," + this.reflexiveColor2.G.ToString() + "," + this.reflexiveColor2.B.ToString());
            writer.WriteLine(this.formBackgroundColor.R.ToString() + "," + this.formBackgroundColor.G.ToString() + "," + this.formBackgroundColor.B.ToString());
            writer.WriteLine(this.itemBackgroundColor.R.ToString() + "," + this.itemBackgroundColor.G.ToString() + "," + this.itemBackgroundColor.B.ToString());
            writer.Flush();
            writer.Close();
            stream.Close();
        }

        [DllImport("uxtheme.dll")]
        private static extern IntPtr SetWindowTheme(IntPtr hWnd, string pszSubAppName, string pszSubIdList);
    }
}

