﻿namespace H2Guerilla.Plugin
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Reflection;

    public class H2GPluginHelper
    {
        public static H2GPluginList Plugins = new H2GPluginList();

        public class H2GPluginList : List<H2GPlugin>
        {
            public void Add(string pluginsPath)
            {
                foreach (FileInfo info in new DirectoryInfo(pluginsPath).GetFiles())
                {
                    Assembly assembly;
                    try
                    {
                        assembly = Assembly.LoadFile(info.FullName);
                    }
                    catch
                    {
                        goto Label_007E;
                    }
                    foreach (Type type in assembly.GetTypes())
                    {
                        if (type.BaseType == typeof(H2GPlugin))
                        {
                            base.Add((H2GPlugin) Activator.CreateInstance(type));
                            base[base.Count - 1].LoadPluginInfo();
                        }
                    }
                Label_007E:;
                }
            }
        }
    }
}

