﻿namespace H2Guerilla.Controls
{
    using core;
    using core.TagInterface;
    using H2Guerilla;
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.IO;
    using System.Windows.Forms;

    public class idents : UserControl
    {
        private BaseObject baseobject;
        private Button button1;
        private Button button2;
        private IContainer components;
        private bool isVaildPath;
        private Label label1;
        public bool nulled;
        private TextBox textBox1;
        private string validPath = "";
        private bool waitForSave = true;

        public idents(BaseObject BaseObject, bool Nulled)
        {
            this.baseobject = BaseObject;
            this.InitializeComponent();
            this.nulled = Nulled;
            this.label1.Text = this.baseobject.Name;
            Main.skin.skinChanged += new EventHandler(this.skin_skinChanged);
            this.BackColor = Main.skin.itemBackgroundColor;
            if (!Nulled)
            {
                this.LoadValue();
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.Filter = "All Files|*.*";
            int length = this.textBox1.Text.LastIndexOf('\\');
            string str = "";
            if (length != -1)
            {
                str = this.textBox1.Text.Substring(0, length);
            }
            string str2 = ProgramSettings.DecompiledTagsPath + @"\H2\" + str + @"\";
            dialog.InitialDirectory = str2;
            TagIdent baseobject = (TagIdent) this.baseobject;
            if (baseobject.TagType != "null")
            {
                TagDefinition tagDefinitionByTagType = Tag_Layouts.GetTagCategory(Map.HaloVersionEnum.Halo2).GetTagDefinitionByTagType(baseobject.TagType);
                dialog.Filter = tagDefinitionByTagType.TagType + " Tags|*." + tagDefinitionByTagType.Extension + "|All Files|*.*";
            }
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                string str3 = dialog.FileName.Replace(Tag_Layouts.GetTagPath(Map.HaloVersionEnum.Halo2), "");
                str3 = str3.Substring(0, str3.IndexOf('.'));
                this.textBox1.Text = str3;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (this.isVaildPath)
            {
                Main.mainForm.OpenWithFilePath(this.validPath);
            }
        }

        private void CheckIfValid()
        {
            TagIdent baseobject = (TagIdent) this.baseobject;
            if (baseobject.TagType == "null")
            {
                this.isVaildPath = false;
            }
            else
            {
                if (this.textBox1.Text == "null")
                {
                    this.isVaildPath = false;
                    this.textBox1.ForeColor = Color.Black;
                }
                TagDefinition tagDefinitionByTagType = Tag_Layouts.GetTagCategory(Map.HaloVersionEnum.Halo2).GetTagDefinitionByTagType(baseobject.TagType);
                string path = (ProgramSettings.DecompiledTagsPath + @"\H2\") + this.textBox1.Text + "." + tagDefinitionByTagType.Extension;
                if (!File.Exists(path))
                {
                    this.textBox1.ForeColor = Color.Red;
                    this.isVaildPath = false;
                }
                else
                {
                    this.textBox1.ForeColor = Color.Black;
                    this.validPath = path;
                    this.isVaildPath = true;
                }
            }
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.label1 = new Label();
            this.textBox1 = new TextBox();
            this.button1 = new Button();
            this.button2 = new Button();
            base.SuspendLayout();
            this.label1.AutoSize = true;
            this.label1.Location = new Point(12, 6);
            this.label1.Name = "label1";
            this.label1.Size = new Size(0x23, 13);
            this.label1.TabIndex = 0;
            this.label1.Text = "label1";
            this.textBox1.Location = new Point(0xb6, 6);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new Size(0x133, 20);
            this.textBox1.TabIndex = 1;
            this.textBox1.TextChanged += new EventHandler(this.textBox1_TextChanged);
            this.button1.Location = new Point(0x1ef, 4);
            this.button1.Name = "button1";
            this.button1.Size = new Size(0x1b, 0x17);
            this.button1.TabIndex = 2;
            this.button1.Text = "...";
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Click += new EventHandler(this.button1_Click);
            this.button2.Location = new Point(0x210, 4);
            this.button2.Name = "button2";
            this.button2.Size = new Size(50, 0x17);
            this.button2.TabIndex = 3;
            this.button2.Text = "Open";
            this.button2.UseVisualStyleBackColor = true;
            this.button2.Click += new EventHandler(this.button2_Click);
            base.AutoScaleDimensions = new SizeF(6f, 13f);
            base.AutoScaleMode = AutoScaleMode.Font;
            this.AutoSize = true;
            base.AutoSizeMode = AutoSizeMode.GrowAndShrink;
            base.Controls.Add(this.button2);
            base.Controls.Add(this.button1);
            base.Controls.Add(this.textBox1);
            base.Controls.Add(this.label1);
            base.Name = "idents";
            base.Size = new Size(0x245, 30);
            base.ResumeLayout(false);
            base.PerformLayout();
        }

        private void LoadValue()
        {
            TagIdent baseobject = (TagIdent) this.baseobject;
            this.label1.Text = baseobject.Name;
            this.textBox1.Text = baseobject.TagName;
            this.CheckIfValid();
            this.waitForSave = false;
        }

        public void ReloadWithNewBaseObject(BaseObject BaseObject)
        {
            this.baseobject = BaseObject;
            this.LoadValue();
        }

        private void SaveValue()
        {
            if (!this.nulled && !this.waitForSave)
            {
                this.CheckIfValid();
                TagIdent baseobject = (TagIdent) this.baseobject;
                baseobject.TagName = this.textBox1.Text;
            }
        }

        public void SetNull()
        {
            this.nulled = true;
            this.textBox1.Clear();
        }

        private void skin_skinChanged(object sender, EventArgs e)
        {
            this.BackColor = Main.skin.itemBackgroundColor;
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            this.SaveValue();
        }
    }
}

