﻿namespace H2Guerilla.Forms
{
    using core;
    using H2Guerilla.Classes;
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;

    public class DatabaseCreate : Form
    {
        private Button button1;
        private Button button2;
        private IContainer components;
        private Label label1;
        private Label label2;
        private Label label3;
        private Label label4;
        private Label label5;
        private PictureBox pictureBox1;
        private DecompiledTagInterface tagInterface;
        private TextBox textBox1;
        private TextBox textBox2;
        private TextBox textBox3;
        private TextBox textBox4;

        public DatabaseCreate()
        {
            this.InitializeComponent();
        }

        public DatabaseCreate(string currentFilePath, DecompiledTagInterface TagInterface)
        {
            this.InitializeComponent();
            this.textBox1.Text = currentFilePath;
            this.textBox1.Enabled = false;
            this.button1.Enabled = false;
            this.tagInterface = TagInterface;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.Filter = "";
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                this.textBox1.Text = dialog.FileName;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            H2DatabaseHandler.DatabaseHeader databaseHeader = new H2DatabaseHandler.DatabaseHeader();
            databaseHeader.Image = this.pictureBox1.Image;
            databaseHeader.Author = this.textBox2.Text;
            databaseHeader.Version = this.textBox3.Text;
            databaseHeader.Description = this.textBox4.Text;
            SaveFileDialog dialog = new SaveFileDialog();
            dialog.Filter = "H2G Database File|*.h2gdf";
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                base.Enabled = false;
                if (this.tagInterface != null)
                {
                    H2DatabaseHandler.CreateDatabase(this.textBox1.Text, this.tagInterface, dialog.FileName, databaseHeader);
                }
                else
                {
                    H2DatabaseHandler.CreateDatabase(this.textBox1.Text, dialog.FileName, databaseHeader);
                }
                base.Enabled = true;
                base.Close();
            }
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.textBox1 = new TextBox();
            this.textBox2 = new TextBox();
            this.textBox3 = new TextBox();
            this.pictureBox1 = new PictureBox();
            this.textBox4 = new TextBox();
            this.button1 = new Button();
            this.button2 = new Button();
            this.label1 = new Label();
            this.label2 = new Label();
            this.label3 = new Label();
            this.label4 = new Label();
            this.label5 = new Label();
            ((ISupportInitialize) this.pictureBox1).BeginInit();
            base.SuspendLayout();
            this.textBox1.Location = new Point(0x72, 0x12);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new Size(0xed, 20);
            this.textBox1.TabIndex = 0;
            this.textBox2.Location = new Point(0x72, 0x2c);
            this.textBox2.Name = "textBox2";
            this.textBox2.Size = new Size(0xed, 20);
            this.textBox2.TabIndex = 1;
            this.textBox3.Location = new Point(0x72, 70);
            this.textBox3.Name = "textBox3";
            this.textBox3.Size = new Size(0xed, 20);
            this.textBox3.TabIndex = 2;
            this.pictureBox1.BorderStyle = BorderStyle.FixedSingle;
            this.pictureBox1.Location = new Point(0x72, 200);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new Size(0xbf, 150);
            this.pictureBox1.SizeMode = PictureBoxSizeMode.Zoom;
            this.pictureBox1.TabIndex = 3;
            this.pictureBox1.TabStop = false;
            this.pictureBox1.Click += new EventHandler(this.pictureBox1_Click);
            this.textBox4.Location = new Point(0x72, 0x5d);
            this.textBox4.Multiline = true;
            this.textBox4.Name = "textBox4";
            this.textBox4.Size = new Size(0xed, 0x65);
            this.textBox4.TabIndex = 4;
            this.button1.Location = new Point(0x165, 0x10);
            this.button1.Name = "button1";
            this.button1.Size = new Size(0x1b, 0x17);
            this.button1.TabIndex = 5;
            this.button1.Text = "...";
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Click += new EventHandler(this.button1_Click);
            this.button2.Location = new Point(0x8e, 0x164);
            this.button2.Name = "button2";
            this.button2.Size = new Size(0x87, 0x17);
            this.button2.TabIndex = 6;
            this.button2.Text = "Create Database";
            this.button2.UseVisualStyleBackColor = true;
            this.button2.Click += new EventHandler(this.button2_Click);
            this.label1.AutoSize = true;
            this.label1.Location = new Point(0x22, 0x15);
            this.label1.Name = "label1";
            this.label1.Size = new Size(0x33, 13);
            this.label1.TabIndex = 7;
            this.label1.Text = "File Path:";
            this.label2.AutoSize = true;
            this.label2.Location = new Point(0x22, 0x2f);
            this.label2.Name = "label2";
            this.label2.Size = new Size(0x29, 13);
            this.label2.TabIndex = 8;
            this.label2.Text = "Author:";
            this.label3.AutoSize = true;
            this.label3.Location = new Point(0x22, 0x49);
            this.label3.Name = "label3";
            this.label3.Size = new Size(0x2d, 13);
            this.label3.TabIndex = 9;
            this.label3.Text = "Version:";
            this.label4.AutoSize = true;
            this.label4.Location = new Point(0x22, 0x60);
            this.label4.Name = "label4";
            this.label4.Size = new Size(0x3f, 13);
            this.label4.TabIndex = 10;
            this.label4.Text = "Description:";
            this.label5.AutoSize = true;
            this.label5.Location = new Point(0x22, 200);
            this.label5.Name = "label5";
            this.label5.Size = new Size(80, 13);
            this.label5.TabIndex = 11;
            this.label5.Text = "Preview Image:";
            base.AutoScaleDimensions = new SizeF(6f, 13f);
            base.AutoScaleMode = AutoScaleMode.Font;
            base.ClientSize = new Size(0x1a2, 0x185);
            base.Controls.Add(this.label5);
            base.Controls.Add(this.label4);
            base.Controls.Add(this.label3);
            base.Controls.Add(this.label2);
            base.Controls.Add(this.label1);
            base.Controls.Add(this.button2);
            base.Controls.Add(this.button1);
            base.Controls.Add(this.textBox4);
            base.Controls.Add(this.pictureBox1);
            base.Controls.Add(this.textBox3);
            base.Controls.Add(this.textBox2);
            base.Controls.Add(this.textBox1);
            base.Name = "DatabaseCreate";
            this.Text = "DatabaseCreate";
            ((ISupportInitialize) this.pictureBox1).EndInit();
            base.ResumeLayout(false);
            base.PerformLayout();
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                this.pictureBox1.Image = Image.FromFile(dialog.FileName);
            }
        }
    }
}

